package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesPrintPartParameterExt;
import cn.estsh.i3plus.ext.mes.pojo.bean.MesShiftExt;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: Xinwang.Yi
 * @CreateDate: 2022/01/11 15:06 下午
 * @Description:
 **/
public interface IPrintPartParameterExtService {
    /**
     * 按条件分页查询打印所需物料拓展信息
     *
     * @param printPartParameterExt 查询条件
     * @param pager 分页条件
     * @return 打印所需物料拓展信息分页数据
     */
    @ApiOperation(value = "按条件分页查询打印所需物料拓展信息", notes = "按条件分页查询打印所需物料拓展信息")
    ListPager<MesPrintPartParameterExt> queryPrintPartParameterExtByPager(MesPrintPartParameterExt printPartParameterExt, Pager pager);

    /**
     * 新增打印所需物料拓展信息
     * @param printPartParameterExt 打印所需物料拓展信息
     * @return 打印所需物料拓展数据
     */
    @ApiOperation(value = "新增打印所需物料拓展信息", notes = "新增打印所需物料拓展信息")
    MesPrintPartParameterExt insertPrintPartParameterExt(MesPrintPartParameterExt printPartParameterExt);

    /**
     * 更新打印所需物料拓展信息
     * @MesPrintPartParameterExt printPartParameterExt 打印所需物料拓展信息
     * @return 打印所需物料拓展数据
     */
    @ApiOperation(value = "更新打印所需物料拓展信息", notes = "更新打印所需物料拓展信息")
    MesPrintPartParameterExt updatePrintPartParameterExt(MesPrintPartParameterExt printPartParameterExt);

    /**
     * 根据id启用或禁用打印所需物料拓展信息
     * @param id 打印所需物料拓展信息ID
     * @param status 状态
     * @param userName 操作人
     * @return 结果
     */
    @ApiOperation(value = "根据id启用或禁用打印所需物料拓展信息", notes = "根据id启用或禁用打印所需物料拓展信息")
    int updatePrintPartParameterExtValidById(Long id, Integer status, String userName);
}
