package cn.estsh.i3plus.ext.mes.api.base.jx;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesOqcRuleNoteDetail;
import cn.estsh.i3plus.ext.mes.pojo.model.jx.JxOqcProjectModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/5 15:41
 **/
public interface IJxOqcProjectService {

    /**
     * 分页查询出货检验项目
     *
     * @param oqcProject 查询条件
     * @param pager 分页条件
     * @return 出货检验项目分页数据
     */
    @ApiOperation(value = "分页查询出货检验项目", notes = "分页查询出货检验项目")
    ListPager<JxOqcProjectModel> queryOqcProjectPager(MesOqcRuleNoteDetail oqcProject, Pager pager);

    /**
     * 新增出货检验项目
     * @param model 出货检验项目信息
     */
    @ApiOperation(value = "新增出货检验项目", notes = "新增出货检验项目")
    void insertOqcProject(JxOqcProjectModel model);

    /**
     * 编辑出货检验项目
     * @param model 出货检验项目信息
     */
    @ApiOperation(value = "编辑出货检验项目", notes = "编辑出货检验项目")
    void updateOqcProject(JxOqcProjectModel model);

    /**
     * 根据ID启用或禁用出货检验项目
     * @param model
     * @param userName
     */
    @ApiOperation(value = "根据ID启用或禁用出货检验项目", notes = "根据ID启用或禁用出货检验项目")
    void updateOqcProjectValidById(JxOqcProjectModel model, String userName);
}
