package cn.estsh.i3plus.ext.mes.api.busi.jx;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesOutPutStatistics;
import cn.estsh.i3plus.ext.mes.pojo.model.jx.JxOutPutStatisticsModel;
import cn.estsh.i3plus.ext.mes.pojo.model.jx.JxOutPutStatisticsQtyModel;
import cn.estsh.i3plus.ext.mes.pojo.model.jx.OqcLastCheckModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/13 9:27
 **/
public interface IJxOutPutStatisticsService {

    /**
     * BU产量统计班次完工数量
     * @param model 查询条件
     * @return BU产量统计班次完工数量
     */
    @ApiOperation(value = "BU产量统计班次完工数量", notes = "BU产量统计班次完工数量")
    List<JxOutPutStatisticsQtyModel> queryOutPutStatisticsQtyList(JxOutPutStatisticsQtyModel model);

    /**
     * 根据条码查找工单信息
     * @param organizeCode 组织代码
     * @return 产量统计
     */
    @ApiOperation(value = "根据 工单号、物料号、班次、产线 查询产量统计数据", notes = "根据条码查找产量统计数据")
    List<MesOutPutStatistics> queryOutPutStatisticsList(OqcLastCheckModel model , String organizeCode);

    /**
     * 根据条码查找工单信息
     * @param organizeCode 组织代码
     * @return 产量统计
     */
    @ApiOperation(value = "根据 工单号、物料号、班次、产线 查询产量统计数据", notes = "根据条码查找产量统计数据")
    List<JxOutPutStatisticsModel> queryOutPutStatisticsModelList(OqcLastCheckModel model , String organizeCode);
}
