package cn.estsh.i3plus.ext.mes.apiservice.dao;


import cn.estsh.i3plus.ext.mes.pojo.bean.MesExteriorScratchProofCell;
import cn.estsh.i3plus.ext.mes.pojo.model.MesExteriorScratchProofCellModel;
import cn.estsh.i3plus.pojo.base.common.Pager;

import java.util.List;

/**
 * @Description : MES外观防划伤工位Dao
 * @Reference :
 * @Author : xiangming.liao
 * @CreateDate : 2020-03-12
 * @Modify:
 **/
public interface IExteriorScratchProofCellDao {

    /**
     * 查询外观防划伤工位数量
     * @param exteriorScratchProofCell 外观防划伤工位
     * @return 数量
     */
    int queryExteriorScratchProofCellByPagerCount(MesExteriorScratchProofCell exteriorScratchProofCell);

    /**
     * 查询外观防划伤工位集合
     * @param exteriorScratchProofCell 查询条件
     * @param pager 分页条件
     * @return 外观防划伤工位集合
     */
    List<MesExteriorScratchProofCellModel> queryExteriorScratchProofCellByPager(MesExteriorScratchProofCell exteriorScratchProofCell, Pager pager);
}
