package cn.estsh.i3plus.ext.mes.apiservice.dao;

import cn.estsh.i3plus.ext.mes.pojo.bean.MesExteriorScratchProofDetail;
import cn.estsh.i3plus.ext.mes.pojo.model.MesExteriorScratchProofDetailModel;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/01/22 17:33
 * @Description:
 **/
public interface IExteriorScratchProofDetailDao {

    /**
     * 外观防划伤明细报表
     * 按条件分页查询外观防划伤明细详情
     * @param exteriorScratchProofDetail
     * @param pager
     * @return
     */
    @ApiOperation(value = "按条件分页查询外观防划伤明细详情", notes = "按条件分页查询外观防划伤明细详情")
    List<MesExteriorScratchProofDetailModel> queryExteriorScratchProofDetailByPager(MesExteriorScratchProofDetail exteriorScratchProofDetail, Pager pager);

    /**
     * 按条件查找单据作业分页数量
     *
     * @param exteriorScratchProofDetail
     * @return
     */
    @ApiOperation(value = "按条件查找单据作业分页数量", notes = "按条件查找单据作业分页数量")
    int queryExteriorScratchProofDetailByPagerCount(MesExteriorScratchProofDetail exteriorScratchProofDetail);
}
