package cn.estsh.i3plus.ext.mes.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年08月23日 8:54
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_WORK_CENTER_NOTIFICATION_BAR")
@Api("MES_产线通知栏")
public class MesWorkCenterNotificationBar extends BaseBean implements Serializable {

    private static final long serialVersionUID = 3618616235240154585L;

    @Column(
            name = "AREA_CODE"
    )
    @ApiParam("生产区域代码")
    private String areaCode;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("生产线代码")
    private String workCenterCode;

    @Column(name = "CONTENT")
    @ApiParam("公告内容")
    private String content;
}
