package cn.estsh.i3plus.ext.mes.pojo.model.bu3;

import cn.estsh.i3plus.ext.mes.pojo.util.MesExtEnumUtil;
import cn.estsh.i3plus.pojo.base.annotation.AnnoOutputColumn;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

/**
 * @DESCRIPTION: 援入援出确认推送钉钉model
 * @USER: jiaqi.hou
 * @DATE: 2023-08-15 10:42
 */
@Data
@ApiModel("援入援出确认推送钉钉model")
public class SxAssistOutAndEnterPushDingInfoModel {

    @ApiParam("产线代码")
    private String workCenterCode;

    @ApiParam(value = "责任部门")
    private String ownerDepartment;

    @ApiParam("工作内容")
    private String workContent;

    @ApiParam("影响人数")
    private Integer influenceNumber;

    @ApiParam("影响时间(分钟)，影响人数*（结束时间-开始时间）")
    private Double influenceTime;

    @ApiParam("影响日期（年月日）")
    private String influenceDate;

    @ApiParam("金额（影响时间*生产线的人件费）")
    private Double amount;

    @ApiParam("外协（备注）")
    private String cooperation;

    @ApiParam("援进援出确认级别")
    @AnnoOutputColumn(refClass = MesExtEnumUtil.ASSIST_OUT_AND_ENTER_CONFIRM_LEVEL.class, refForeignKey = "value", value = "description")
    private Integer assistOutAndEnterConfirmLevel;

    @ApiParam("推送用户")
    private String userNames;

    public SxAssistOutAndEnterPushDingInfoModel() {}
}
